

% SIN_EACD_11_Forecasting_1_Test_Statistics_vol

% 1. Test Statistics

function Out = SIN_EACD_11_Forecasting_1_Test_Statistics_vol(y)

% Input

SIN_Intervals = load('SIN_Intervals');  % Interval selection
K = 14;                                 % Number of intervals equals (K + 1)
Th_vol_Q1 = load('Th_vol_Q1');
Th_vol_Q2 = load('Th_vol_Q2');
Th_vol_Q3 = load('Th_vol_Q3');
z_k_b_Th_vol_Q1 = load('z_k_b_Th_vol_Q1');
z_k_b_Th_vol_Q2 = load('z_k_b_Th_vol_Q2');
z_k_b_Th_vol_Q3 = load('z_k_b_Th_vol_Q3');
% SIN_EACD_11_Estimation_Likelihood.m
% SIN_EACD_11_Test_Statistics_Sort.m

% Programme Code

y_daily_estimate = SIN_EACD_11_Estimation(y);
y_daily_persistence = y_daily_estimate(2, 1) + y_daily_estimate(3, 1);
if y_daily_persistence <= ((Th_vol_Q1(2, :) + Th_vol_Q1(3, :)) + (Th_vol_Q2(2, :) + Th_vol_Q2(3, :))) / 2
  z_k = z_k_b_Th_vol_Q1(:, 1);
end
if y_daily_persistence >= ((Th_vol_Q3(2, :) + Th_vol_Q3(3, :)) + (Th_vol_Q2(2, :) + Th_vol_Q2(3, :))) / 2
  z_k = z_k_b_Th_vol_Q3(:, 1);
end
if y_daily_persistence < ((Th_vol_Q3(2, :) + Th_vol_Q3(3, :)) + (Th_vol_Q2(2, :) + Th_vol_Q2(3, :))) / 2 && y_daily_persistence > ((Th_vol_Q1(2, :) + Th_vol_Q1(3, :)) + (Th_vol_Q2(2, :) + Th_vol_Q2(3, :))) / 2
  z_k = z_k_b_Th_vol_Q2(:, 1);
end

b_y_Jk = cell(K - 1, 1); b_o_Jk = cell(K - 1, 1); b_L3 = zeros(K - 1, 1);
b_L11 = zeros(K - 1, 1); b_L21 = zeros(K - 1, 1);
b_L12 = zeros(K - 1, 1); b_L22 = zeros(K - 1, 1);
b_L13 = zeros(K - 1, 1); b_L23 = zeros(K - 1, 1);

k = 1;
  b_y_Jk{k} = y(SIN_Intervals(k + 1, 3) : SIN_Intervals(k + 1, 4));
  b_o_Jk{k} = SIN_EACD_11_Test_Statistics_Sort(b_y_Jk{k});
  b_L11(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k})) - 2));
  b_L12(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 1) - 2));
  b_L13(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 2) - 2));
  b_L21(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k})) - 1 : end));
  b_L22(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 1) - 1 : end));
  b_L23(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 2) - 1 : end));
  b_L3(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : end));
b_T1 = b_L11 + b_L21 - b_L3; b_T2 = b_L12 + b_L22 - b_L3; b_T3 = b_L13 + b_L23 - b_L3;
b_T1T2T3 = [b_T1, b_T2, b_T3]; b_T = max(b_T1T2T3, [], 2);

for k = 2 : 1 : K - 1
  if b_T(k - 1) <= z_k(k - 1)
    b_y_Jk{k} = y(SIN_Intervals(k + 1, 3) : SIN_Intervals(k + 1, 4));
    b_o_Jk{k} = SIN_EACD_11_Test_Statistics_Sort(b_y_Jk{k});
    b_L11(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k})) - 2));
    b_L12(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 1) - 2));
    b_L13(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 2) - 2));
    b_L21(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k})) - 1 : end));
    b_L22(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 1) - 1 : end));
    b_L23(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 2) - 1 : end));
    b_L3(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : end));
    b_T1(k) = b_L11(k) + b_L21(k) - b_L3(k); b_T2(k) = b_L12(k) + b_L22(k) - b_L3(k); b_T3(k) = b_L13(k) + b_L23(k) - b_L3(k);
    b_T1T2T3(k, :) = [b_T1(k), b_T2(k), b_T3(k)]; b_T(k) = max(b_T1T2T3(k, :), [], 2);
  else
    b_T(k) = 100;
  end
end

% Output

Out = b_T;

end


