

% SIN_EACD_11_Estimation_Likelihood

function Out = SIN_EACD_11_Estimation_Likelihood(y)

% Input
% SIN_EACD_11_Likelihood.m

% Programme Code
Objective = @(Th) - SIN_EACD_11_Likelihood(y, Th);
Options = optimset('Display', 'off', 'Algorithm', 'interior-point', 'Hessian', 'bfgs', 'MaxIter', 50);
Th0 = [0.05, 0.10, 0.70]'; A = [-1, 0, 0; 0, -1, 0; 0, 0, -1; 0, 1, 1]; b = [-0.0001; -0.0001; -0.0001; 0.9999];
[~, Out] = fmincon(Objective, Th0, A, b, [], [], [], [], [], Options);

% Output
Out = -Out;

end


